plugins {
    java
    application
    id("org.jetbrains.kotlin.jvm") version "1.8.10"
    id("org.openjfx.javafxplugin") version "0.0.13"
    id("com.github.johnrengelman.shadow") version "7.1.0"
}

group = "io.gitlab.jfronny"
version = "1.0-SNAPSHOT"

repositories {
    mavenCentral()
}

java {
    sourceCompatibility = JavaVersion.VERSION_17
    targetCompatibility = JavaVersion.VERSION_17
}

tasks.withType(JavaCompile::class) {
    options.encoding = "UTF-8"
}

application {
    mainClass.set("io.gitlab.jfronny.compareimage.HelloApplicationKt")
}

val javaVer = java.targetCompatibility.name.substring("VERSION_".length)

listOf(tasks.compileKotlin, tasks.compileTestKotlin).forEach {
    it {
        kotlinOptions.jvmTarget = javaVer
    }
}

javafx {
    version = javaVer
    modules = listOf("javafx.controls", "javafx.fxml")
}
